# Poco

# template < class PRF >

# class PBKDF2Engine

Library: Foundation
Package: Crypt
Header: Poco/PBKDF2Engine.h

## Description

This class implements the Password-Based Key Derivation Function 2, as specified in RFC 2898. The underlying DigestEngine (HMACEngine, etc.), which must accept the passphrase as constructor argument (std::string), must be given as template argument.

PBKDF2 (Password-Based Key Derivation Function 2) is a key derivation function that is part of RSA Laboratories' Public-Key Cryptography Standards (PKCS) series, specifically PKCS #5 v2.0, also published as Internet Engineering Task Force's RFC 2898. It replaces an earlier standard, PBKDF1, which could only produce derived keys up to 160 bits long.

PBKDF2 applies a pseudorandom function, such as a cryptographic hash, cipher, or HMAC to the input password or passphrase along with a salt value and repeats the process many times to produce a derived key, which can then be used as a cryptographic key in subsequent operations. The added computational work makes password cracking much more difficult, and is known as key stretching. When the standard was written in 2000, the recommended minimum number of iterations was 1000, but the parameter is intended to be increased over time as CPU speeds increase. Having a salt added to the password reduces the ability to use precomputed hashes (rainbow tables) for attacks, and means that multiple passwords have to be tested individually, not all at once. The standard recommends a salt length of at least 64 bits. [Wikipedia]

The PBKDF2 algorithm is implemented as a DigestEngine. The passphrase is specified by calling update().

Example (WPA2):

    PBKDF2Engine<HMACEngine<SHA1Engine>> pbkdf2(ssid, 4096, 256);
    pbkdf2.update(passphrase);
    DigestEngine::Digest d = pbkdf2.digest();

## Inheritance

Direct Base Classes: DigestEngine

All Base Classes: DigestEngine

## Member Summary

Member Functions: digest, digestLength, f, reset, updateImpl

Inherited Functions: constantTimeEquals, digest, digestFromHex, digestLength, digestToHex, reset, update, updateImpl

## Enumerations

### Anonymous

PRF_DIGEST_SIZE = PRF::DIGEST_SIZE

## Constructors

### PBKDF2Engine

PBKDF2Engine(
const std::string & salt,
unsigned c = 4096,
Poco::UInt32 dkLen = PRF_DIGEST_SIZE
);

## Destructor

### ~PBKDF2Engine

~PBKDF2Engine();

## Member Functions

### digest

const DigestEngine::Digest & digest();

### digestLength

std::size_t digestLength() const;

See also: Poco::DigestEngine::digestLength()

### reset

void reset();

See also: Poco::DigestEngine::reset()

### f

void f(
Poco::UInt32 i
);

### updateImpl

void updateImpl(
const void * data,
std::size_t length
);

See also: Poco::DigestEngine::updateImpl()